<script>
    import { Modal } from "flowbite-svelte";
    import { show_info } from "./svelte_stores/show_panes_store.js";
    import { P, A, Li, List, Heading } from "flowbite-svelte";
</script>

<Modal bind:open={$show_info} size="md" autoclose outsideclose>
    <div slot="header">
        <h1 class="text-3xl font-bold">The KNMI HAPI timeline viewer</h1>
    </div>
    <div class="space-y-3">
        <Heading tag="h2" class="text-xl font-bold">Introduction</Heading>
        <P color="text-gray-500 dark:text-gray-400"
            >This HAPI timeline viewer was developed in the space weather group
            at <A href="https://www.knmi.nl/">KNMI</A>, the Royal Netherlands
            Meteorological Institute. This group is part of the R&D Satellite
            Observations section of KNMI. For questions, feedback and bug
            reports, don't hesitate to contact Eelco Doornbos by <A
                href="mailto:eelco.doornbos@knmi.nl">e-mail</A
            >.</P>

        <P color="text-gray-500 dark:text-gray-400"
            >The development of this application was partly funded under the <A
                class="underline hover:no-underline"
                href="https://earth.esa.int/eogateway/activities/swarm-disc"
                >ESA Swarm DISC</A> project <A
                class="underline hover:no-underline"
                href="https://earth.esa.int/eogateway/activities/swarm-switch"
                >Swarm-SWITCH</A
            >.</P>

        <Heading tag="h2" class="text-xl font-bold">Under the hood</Heading>
        <P color="text-gray-500 dark:text-gray-400"
            >The timeline viewer is an open source project, relying heavily on
            the <A href="http://www.hapi-server.org">HAPI specification</A>. It
            is written using the <A href="https://svelte.dev/"
                >Svelte Javascript framework</A
            >, and making use of <A
                href="https://sveltequery.vercel.app/guides/prefetching"
                >Svelte Query</A> for fetching and caching data, <A
                href="https://flowbite-svelte.com/">Flowbite Svelte</A> for user
            interface components and <A href="https://d3js.org/">D3.js</A> for help
            with the graphical display of information.</P>

        <P color="text-gray-500 dark:text-gray-400"
            >If you are interested in looking at how the project was written, or
            perhaps even in helping with further development, have a look at <A
                href="https://gitlab.com/KNMI-OSS/spaceweather/knmi-hapi-timeline-viewer"
                >the Gitlab repository</A
            >. The Gitlab <A href="">Issues page for the project</A> is a great place
            to leave bug reports or feature requests, but it is of course also possible
            to send these by <A href="mailto:eelco.doornbos@knmi.nl">e-mail</A
            ></P>

        <P color="text-gray-500 dark:text-gray-400"
            >KNMI is developing a <A href="http://www.hapi-server.org"
                >HAPI server</A>
            with special datasets at multiple cadences, to enable the ability to
            zoom in and out over a large extent of time spans. In addition, the display
            of images and events on the timeline will be enabled using this server.
            Hopefully, other data providers using HAPI can enable such features as
            well in the future.</P>

        <P color="text-gray-500 dark:text-gray-400"
            >The experience of panning and zooming on the timeline works best
            with datasets that are available at multiple cadences that have been
            linked together. Currently, such data cadence linking is only fully
            available for datasets on the KNMI HAPI server. For datasets on the
            Intermagnet server, it is possible to automatically switch between 1
            second and 1 minute cadence, but both cadences are not always
            available for all datasets and time periods. Otherwise, it is
            necessary to zoom in far enough, in order to see the data appear. It
            is also necessary to look during the time period for which data is
            available. In the future, user interface elements will be added to
            indicate where the user has to zoom or pan to view the data.</P>

        <Heading tag="h2" class="text-xl font-bold"
            >Bugs and feature requests</Heading>
        Issues, such as bug reports and feature requests can be added and tracked
        in the gitlab repository:
        <A
            href="https://gitlab.com/KNMI-OSS/spaceweather/knmi-hapi-timeline-viewer/-/issues"
            >https://gitlab.com/KNMI-OSS/spaceweather/knmi-hapi-timeline-viewer/-/issues</A>

        <Heading tag="h2" class="text-xl font-bold"
            >Log of changes to the viewer</Heading>
        <List tag="ul" class="space-y-4 text-gray-500 dark:text-gray-400">
            <Li
                ><b>2025-01-19</b>
                <List tag="ul" class="ps-5 mt-2 space-y-1">
                    <Li
                        >The development console provides information for when
                        datasets are out of view, helpful when adding new
                        datasets.
                    </Li>
                    <Li
                        >The cadence override field, required when adding
                        datasets that do not provide their cadence in the HAPI
                        info requests, is highlighted in red, when no valid
                        value is available.
                    </Li>
                    <Li>
                        The startDate and stopDate fields from the HAPI info
                        request are used when constructing data requests for the
                        Intermagnet server, so that the data appears in the
                        viewer, even if the view start and stop overlap with the
                        data's start and stop dates.
                    </Li>
                </List>
            </Li>
            <Li
                ><b>2025-01-11</b>
                <List tag="ul" class="ps-5 mt-2 space-y-1">
                    <Li
                        >Added a button to the top navigation bar to allow
                        download of the SVG plot (3D rendered Earth view and
                        bitmap images are not supported by this).
                    </Li>
                    <Li>
                        Moved the dark mode button from the global optionsto the
                        top navigation bar
                    </Li>
                </List>
            </Li>
        </List>

        <Heading tag="h2" class="text-xl font-bold"
            >Log of changes to the KNMI HAPI server</Heading>
        <List tag="ul" class="space-y-4 text-gray-500 dark:text-gray-400">
            <Li
                ><b>2025-01-19</b>
                <List tag="ul" class="ps-5 mt-2 space-y-1">
                    <Li
                        >The GOES X-ray flux classification data
                        (xray_flux_flare_class) has been extended backwards
                        using xrsf-l2-flsum science data from GOES 8 to GOES 12
                        (1995-2008).
                    </Li>
                </List>
            </Li>
        </List>

        <div></div>
    </div></Modal>
